#!/bin/bash

set -e
set -x

umask 0022

VERSION=${VERSION:-3.4.0}
VERSION_PARENT=${VERSION%.[0-9]}

CURRENT_DIR=$(pwd)

TMPDIR=$(mktemp -d /var/tmp/cairo-dock-XXXXXX)
pushd $TMPDIR

#wget -N http://launchpad.net/cairo-dock-plug-ins/${VERSION_PARENT}/${VERSION}/+download/cairo-dock-plugins-${VERSION}.tar.gz
wget -N https://github.com/Cairo-Dock/cairo-dock-plug-ins/archive/${VERSION}/cairo-dock-plugins-${VERSION}.tar.gz
rm -rf cairo-dock-plugins-${VERSION}
tar xzf cairo-dock-plugins-${VERSION}.tar.gz

if [ -d cairo-dock-plug-ins-${VERSION} ] ; then
	mv cairo-dock-plug{-,}ins-${VERSION}
fi

pushd cairo-dock-plugins-${VERSION}

rm -rf Scooby-Do/
sed -i -e '\@SCOOBY_DO@,\@endif@d' -e '\@with_scooby_do@d' CMakeLists.txt

pushd desklet-rendering
rm -f data/starcraft2.png
sed -i -e '\@starcraft2@d' data/CMakeLists.txt
sed -i -e '\@_register_desklet_decorations.*none@i REMOVE_TO_HERE' src/rendering-desklet-decorations.c
sed -i -e '\@_register_desklet_decorations.*futuristic@,\@REMOVE_TO_HERE@d' src/rendering-desklet-decorations.c
popd

cp -p ./weather/data/themes/Classic/na.png ./weather/data/broken.png

popd

tar czf cairo-dock-plugins-fedora-${VERSION}.tar.gz cairo-dock-plugins-${VERSION}/
mv cairo-dock-plugins-fedora-${VERSION}.tar.gz ${CURRENT_DIR}/

popd
rm -rf $TMPDIR

